<%@ Assembly Name="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, 
PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" Inherits="Microsoft.SharePoint.WebPartPages.WikiEditPage" 
MasterPageFile="~masterurl/default.master" %>
<%@ Register TagPrefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" 
Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, 
PublicKeyToken=71e9bce111e9429c" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitle' runat='server'>
    Drag and Drop Files Test
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitleInTitleArea' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderAdditionalPageHead' runat='server'>
    <script type="text/javascript">
        window.Promise || document.write('<script src="https://cdn.jsdelivr.net/npm/es6-promise@4/dist/es6-promise.auto.js"><\/script>');
    </script>
    <script src="https://cdn.jsdelivr.net/npm/whatwg-fetch@2.0.4/fetch.js"></script>
    <style type="text/css">
        #dragandrophandler {
            border: 2px dotted grey;
            width: 400px;
            height: 200px;
            color: #92AAB0;
            margin-bottom: 10px;
            font-size: 2em;
            text-align: center;
            vertical-align: middle;
            line-height: 200px;
            background-color: lightgrey;
        }

        #dragandrophandler.dragover {
            border: 2px solid black;
            background-color: darkgrey;
        }

        .ms-status-yellow {
            display: none !important;
        }

        .updatepanel {
            padding: 5px 30px;
            border: 1px solid lightgrey;
            width: 340px;
            margin: 20px 0;
            display: none;
        }

    </style>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMiniConsole' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderLeftActions' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMain' runat='server'>

    <ul id="picturelist" style="list-style: none">
    </ul>

    <div id="updatePanel" class="updatepanel">
        <p>
            Title:
            <input type='text' id='title' val='' />
        </p>
        <p>
            Description:
            <input type='text' id='description' val='' />
        </p>
        <p>
            <button type='button' id='Update'>
                Update
            </button>
            <button type='button' id='Delete'>
                Delete
            </button>
        </p>
    </div>

    <div id="dragandrophandler">
        <div id="draganddropbusy" style="display:none">
            <img src="/_layouts/images/progress.gif">
        </div>
        <div id="draganddroplabel">Drag & Drop Images To Add</div>
    </div>

    <script type="text/javascript">
        var listTitle = "Pictures";

        var uploading = 0;

        /*=========================================================
        Upload an image to a picture library.
        =========================================================*/
        function createImage(file) {
            var reader = new FileReader();

            reader.onloadend = function(evt) {
                var buffer = evt.target.result;

                if (uploading == 0) {
                    document.getElementById("draganddroplabel").style.display = "none";
                    document.getElementById("draganddropbusy").style.display = "block";
                }
                uploading++;

                function decrement() {
                    uploading--;
                    if (!uploading) {
                        document.getElementById("draganddroplabel").style.display = "block";
                        document.getElementById("draganddropbusy").style.display = "none";
                        readImages();
                    }
                }

                var url = _spPageContextInfo.webAbsoluteUrl +
                    "/_api/web/lists/getByTitle('" + listTitle + "')" +
                    "/RootFolder/Files/add(url='" + file.name + "',overwrite='true')?" +
                    "@TargetLibrary='" + listTitle + "'&@TargetFileName='" + file.name + "'";

                UpdateFormDigest(_spPageContextInfo.webServerRelativeUrl, _spFormDigestRefreshInterval);
                
                fetchx(url, {
                    method: "POST",
                    headers: {
                        "accept": "application/json;odata=nometadata",
                        "X-RequestDigest": document.getElementById("__REQUESTDIGEST").value
                    },
                    body: buffer
                }).then(function(json) {
                    decrement();
                }).catch(function(error) {
                    alertError(error);
                });

            };

            reader.readAsArrayBuffer(file);
        }

        /*=========================================================
        Read in images from the picture library.
        =========================================================*/
        function readImages() {
            var index = 0;

            var selected = document.querySelector("input[name='item']:checked");
            if (selected) {
                index = selected.value;
            }

            var pictureList = document.getElementById("picturelist");

            var serviceUrl = "/_api/Web/Lists/getByTitle('" + listTitle + "')/Items";
            var serviceParams = "$select=FileRef,Title,Description,Id,Created,Modified,GUID&$expand=File";
            var url = _spPageContextInfo.webAbsoluteUrl + serviceUrl + "?" + serviceParams;

            fetchx(url, {
                method: "GET",
                url: url,
                headers: new Headers({
                    'accept': 'application/json;odata=nometadata'
                })
            }).then(function(json) {
                for (var i = 0; i < json.value.length; i++) {
                    var current = json.value[i];
                    current.Name = current.FileRef;
                    current.Name = current.Name.substr(current.Name.lastIndexOf("/") + 1);
                    current.Title = current.Title || "";
                    current.Description = current.Description || "";
                    
                    if(current.File && current.File.ETag) {
                        var tmp = current.File.ETag;
                        if(tmp.indexOf(",") > 0) {
                            current.eTag = tmp.substr(tmp.indexOf(",") + 1);
                        }
                    }

                    var input = document.getElementById("item" + current.ID);
                    if (input) {
                        var li = input.parentNode;
                        li.setAttribute("data-title", current.Title);
                        li.setAttribute("data-description", current.Description);
                        if(current.eTag) li.setAttribute("data-etag", current.etag);
                    } else {
                        var container = document.createElement("div");
                        container.innerHTML = "<li data-id='" + current.ID + "' " +
                            "data-title='" + current.Title + "' " +
                            "data-description='" + current.Description + "' " +
                            (current.eTag ? "data-etag=''" + current.eTag + "''" : "") + ">" +
                            "<input type='radio' name='item' id='item" + current.ID +
                            "' value='" + current.ID + "' />" +
                            current.Name + "</li>";
                        pictureList.appendChild(container.children[0]);
                    }
                }

                if (index) {
                    var current = document.getElementById("item" + index);
                    current.checked = true;
                    var title = current.parentNode.getAttribute("data-title");
                    var description = current.parentNode.getAttribute("data-description");
                    document.getElementById("title").value = title;
                    document.getElementById("description").value = description;
                    document.getElementById("updatePanel").style.display = "block";
                } else {
                    document.getElementById("updatePanel").style.display = "none";
                    document.getElementById("title").value = "";
                    document.getElementById("description").value = "";
                }
            }).catch(function(error) {
                alertError(error);
            });
        }

        /*=========================================================
        Update the title and description in a picture library.
        =========================================================*/
        function updateImage(id) {
            var changes = {
                'Title': document.getElementById("title").value,
                'Description': document.getElementById("description").value
            };
            changes = JSON.stringify(changes);

            var serviceUrl = "/_api/Web/Lists/getByTitle('" + listTitle + "')/Items(" + id + ")";
            var url = _spPageContextInfo.webAbsoluteUrl + serviceUrl;

            fetchx(url, {
                method: "MERGE",
                headers: {
                    'accept': 'application/json;odata=nometadata',
                    'content-Type': 'application/json;odata=nometadata',
                    'X-RequestDigest': document.getElementById("__REQUESTDIGEST").value,
                    'X-HTTP-Method': 'MERGE',
                    'IF-MATCH': '*'
                },
                body: changes
            }).then(function() {
                readImages();
                alert("Successfully updated the item!");
            }).catch(function(error) {
                alertError(error);
            });
        }

        /*=========================================================
        Delete an image in a picture library.
        =========================================================*/
        function deleteImage(id) {
            var name = document.querySelector("li[data-id='" + id + "']").textContent;

            var base = (_spPageContextInfo.webServerRelativeUrl === "/" ? "" : _spPageContextInfo.webServerRelativeUrl);
            var serviceUrl = "/_api/web/getfilebyserverrelativeurl('" + base + "/" + listTitle + "/" + name + "')";
            var url = _spPageContextInfo.webAbsoluteUrl + serviceUrl;

            fetchx(url, {
                method: "DELETE",
                headers: {
                    'accept': 'application/json;odata=nometadata',
                    'X-RequestDigest': document.getElementById("__REQUESTDIGEST").value,
                    'X-HTTP-Method': 'DELETE'
                },
            }).then(function(json) {
                var current = document.getElementById("item" + id);
                current.parentNode.parentNode.removeChild(current.parentNode);
                document.getElementById("updatePanel").style.display = "none";
                readImages();
            }).catch(function(error) {
                alertError(error);
            });
        }
        
        function alertError(error) {
            if(error.status && error.statusText) {
                alert(error.status + " " + error.statusText);
            }
            else {
                alert(error);
            }
        }

        /*=========================================================
        Wrap fetch
        =========================================================*/
        function fetchx(url, init) {
            init = init || {};

            // all SharePoint operations are going to need this, so let's default.
            init.credentials = "include";

            // turn objects into Headers, also see if we're expecting a json response
            if (init.headers && !(init.headers instanceof Headers)) {
                init.headers = new Headers(init.headers);
            }

            /*
             Call fetch, process obvious error responses, pre-process json responses, and
             return the promise for further processing.
             */
            return fetch(url, init).then(function(response) {
                // non-success response
                if (response.stataus < 200 || response.status >= 400) {
                    throw response;
                }

                // no content by design
                if (response.status === 204) {
                    return response;
                }

                // no content, but not not by design?
                if (response.headers.get("content-length") === "0") {
                    return response;
                }

                // process json responses
                if(init.headers) {
                    var accept = init.headers.get("accept");
                    if (accept && accept.indexOf("application/json") > -1) {
                        var contentType = response.headers.get("content-type");
                        if (contentType && contentType.indexOf("application/json") > -1) {
                            return response.json();
                        } else {
                            throw new TypeError("Oops, should have gotten JSON, but didn't!");
                        }
                    }
                }

                // no errors and some kind of payload, but also not json
                return response.text();
            });
        }

        // don't do anything until sp.js is loaded
        ExecuteOrDelayUntilScriptLoaded(function() {
            readImages();
        }, "sp.js");

        // populate the edit form and show it when the radio button next to an 
        // image is selected
        document.getElementById("picturelist").addEventListener("change", function(e) {
            if (e.target.type === "radio") {
                var item = e.target.parentNode;
                var title = item.getAttribute("data-title");
                var description = item.getAttribute("data-description");
                document.getElementById("title").value = title;
                document.getElementById("description").value = description;
                document.getElementById("updatePanel").style.display = "block";
            }
        }, false);

        // callback for the update button
        document.getElementById("Update").addEventListener("click", function(e) {
            var current = document.querySelector("input[name='item']:checked");
            updateImage(current.value);
        }, false);

        // callback for the delete button
        document.getElementById("Delete").addEventListener("click", function(e) {
            var current = document.querySelector("input[name='item']:checked");
            deleteImage(current.value);
        }, false);

        // process all dropped files
        function handleFileUpload(files) {
            var fileArray = [];
            // push all files to upload into an array
            for (var i = 0; i < files.length; i++) {
                fileArray.push(files[i]);
            }

            // This get's called once per second. uploading is a global variable that contains
            // the number of uploads that are in progress right now. Each time we're called,
            // process up to (5 - uploading) files, or fileArray.length files (the number of files 
            // that have not been uploaded yet), whatever is less.
            function doUpTo5Files() {
                while (fileArray.length > 0 && uploading < 5) {
                    // as we process a file, remove it from the array
                    var file = fileArray.splice(0, 1);
                    // now upload it to SharePoint
                    createImage(file[0]);
                }
            }

            // process the first 5 files
            doUpTo5Files();
            // if there are still more files
            if (fileArray.length > 0) {
                // once a second, process up to five more files
                var id = setInterval(function() {
                    doUpTo5Files();
                    // if all files have been uploaded, stop the timer
                    if (fileArray.length === 0) {
                        clearInterval(id);
                    }
                }, 1000);
            }
        }

        // get the div we'll use for drag and drop
        var div = document.getElementById("dragandrophandler");

        // add a the dragover class to the div when files are dragged into it
        div.addEventListener('dragenter', function(e) {
            e.stopPropagation();
            e.preventDefault();
            div.classList.add("dragover");
        }, false);

        // add a the dragover class to the div when files are dragged over it
        div.addEventListener("dragover", function(e) {
            e.stopPropagation();
            e.preventDefault();
            div.classList.add("dragover");
        }, false);

        // remove the dragover class from the div when files are dragged out of it
        div.addEventListener("dragleave", function(e) {
            e.stopPropagation();
            e.preventDefault();
            div.classList.remove("dragover");
        }, false);

        // upload files to SharePoint when they are dropped on the div
        div.addEventListener("drop", function(e) {
            e.stopPropagation();
            e.preventDefault();
            div.classList.remove("dragover");
            var files = e.dataTransfer.files;
            handleFileUpload(files);
        }, false);

    </script>

</asp:Content>
